package common;

public class Persona implements Comparable<Persona> {
	private String codiceFiscale;
	private int eta;
	
	public Persona(String codiceFiscale, int eta) {
		super();
		this.codiceFiscale = codiceFiscale;
		this.eta = eta;
	}

	public String getCodiceFiscale() {
		return codiceFiscale;
	}

	public void setCodiceFiscale(String codiceFiscale) {
		this.codiceFiscale = codiceFiscale;
	}

	public int getEta() {
		return eta;
	}

	public void setEta(int eta) {
		this.eta = eta;
	}
	
	@Override
	public String toString() {
		return "Codice Fiscale: " + codiceFiscale + 
				" - Età: " + eta;
	}
	
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof Persona) {
			Persona p = (Persona) obj;
			return p.codiceFiscale.equals(codiceFiscale);
		}
		return false;
	}
	
	@Override
	public int compareTo(Persona p) {
		/*Restituisce un intero positivo se l'oggetto corrente
		* è maggiore (secondo qualche criterio) dell'oggetto p
		* 
		* Restituisce un intero negativo se l'oggetto corrente
		* è minore (secondo qualche criterio) dell'oggetto p
		* 
		* Restituisce 0 se l'oggetto corrente 
		* è uguale (secondo qualche criterio) dell'oggetto p */
		if(this.getEta() > p.getEta())
			return 1;
		else if(this.getEta() < p.getEta())
			return -1;
		return 0;
	}
	
	@Override
	public int hashCode() {
		return codiceFiscale.hashCode();
	}
}













