package esempicollections;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import common.Persona;

public class TestCollections {

	public static void main(String[] args) {
		List<Persona> l = new ArrayList<Persona>();
		Persona p1 = new Persona("CF1",24);
		Persona p2= new Persona("CF2",21);
		Persona p3 = new Persona("CF3",28);
		Persona p4 = new Persona("CF1",24);
		l.add(p1);
		l.add(p2);
		l.add(p3);
		
		if(l.contains(p4)) {
			System.out.println("P4 è contenuto perché abbiamo ridefinito equals in Persona");
		}
		
		//Stampa della lista
		System.out.println(l);
		
		Persona pMax = Collections.max(l);
		System.out.println("La persona con l'età più alta: " + pMax);
		Persona pMin = Collections.min(l);
		System.out.println("La persona con l'età più bassa: " + pMin);
		
		//Inverte la lista
		Collections.reverse(l);
		System.out.println("Lista invertita: " + l);
		
		//Ordinare una lista di oggetti di persona
		Collections.sort(l); //Funziona perché Persona implementa Comparable
		
		//Possiamo creare un comparatore specifico per Persona e poi usarlo per ordinare
		ComparatorePersona c = new ComparatorePersona();	
		Collections.sort(l, c);
		
		//Possiamo implementare il Comparatore usando una classe anonima
		Collections.sort(l, new Comparator<Persona>() {
			public int compare(Persona o1, Persona o2) {
				if(o1.getEta() > o2.getEta())
					return 1;
				else if(o1.getEta() < o2.getEta())
					return -1;
				return 0;
			}
		});
		System.out.println("Lista ordinata: " + l);		
	}
}
